# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_attr.ipynb.

# %% auto 0
__all__ = ['hasshape', 'hasdf', 'hascols', 'hascolumns', 'hasidx', 'hasindex', 'hasloc', 'hasiloc', 'hasicat', 'hasds']

# %% ../nbs/10_attr.ipynb 4
from typing import TypeGuard
from typing import Callable

# %% ../nbs/10_attr.ipynb 5
from atyp import IndexLike, DataFrame
from nlit import SHAPE, COLUMNS, INDEX, DF, IDX, LOC, ILOC, ICAT, COLS, DS
from chck import isdf, isds

# %% ../nbs/10_attr.ipynb 6
from .core import make

# %% ../nbs/10_attr.ipynb 9
@make(SHAPE)
def hasshape(obj) -> TypeGuard[object]: '''Checks if `obj.shape` exists'''

# %% ../nbs/10_attr.ipynb 12
@make(DF)
def hasdf(obj) -> TypeGuard[DataFrame]: '''Checks if `obj.df` exists'''

# %% ../nbs/10_attr.ipynb 13
@make(COLS)
def hascols(x) -> TypeGuard[DataFrame]: ...

@make(COLUMNS)
def hascolumns(obj) -> TypeGuard[DataFrame]: '''Checks if `obj.columns` exists'''

# %% ../nbs/10_attr.ipynb 14
@make(IDX)
def hasidx(x, default = None) -> TypeGuard[DataFrame] | None: ...

@make(INDEX)
def hasindex(x, default = None) -> TypeGuard[DataFrame] | None: ...

# %% ../nbs/10_attr.ipynb 15
@make(LOC, otype=isdf)
def hasloc(x, default = None) -> TypeGuard[IndexLike] | None: ...

@make(ILOC, otype=isdf)
def hasiloc(x, default = None) -> TypeGuard[IndexLike] | None: ...

@make(ICAT, otype=isdf)
def hasicat(x, default = None) -> TypeGuard[IndexLike] | None: ...

# %% ../nbs/10_attr.ipynb 17
@make(DS, guard=isds, retself=True)
def hasds(x, default = None) -> TypeGuard[object] | None: ...
